/*
 * CancelSubscriptions.java
 *
 * (C) Copyright IBM Corp. 2002 2004
 * 
 * THIS FILE IS PROVIDED UNDER THE TERMS OF THE COMMON PUBLIC LICENSE 
 * ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THIS FILE 
 * CONSTITUTES RECIPIENTS ACCEPTANCE OF THE AGREEMENT.
 *
 * You can obtain a current copy of the Common Public License from
 * http://oss.software.ibm.com/developerworks/opensource/license-cpl.html
 *
 * Author: Viktor Mihajlovski <MIHAJLOV@de.ibm.com>
 * Contributors: Rajarshi Das <rajarshi@in.ibm.com>
 *
 * Description: Cancels subscriptions previously established.
 */

package com.ibm.wbem.evsub;

import org.snia.wbem.client.*;
import org.snia.wbem.cim.*;

public class CancelSubscriptions {
    public static void main(String args[]) {
	try 
	{
	    String temp = null;
	    CIMNameSpace cns = new CIMNameSpace(args[0],"root/cimv2");
	    CIMClient cc = new CIMClient(cns,args[1],args[2]);
	    IndicationArbiter ia = new IndicationArbiter(cc,args[3]);
	    System.out.println("Successfully canceled subscriptions for " +
			       cns);
	}
	catch (ArrayIndexOutOfBoundsException e)
	{
		System.out.println("Please specify a parameter to cancelsub.sh");
		System.out.println("as : cleanrepos/<pid of the createsub.sh process to");
	  	System.out.println(" be cancelled>");
		e.printStackTrace();
	}
	catch (Exception exc) {
	    exc.printStackTrace();
	}
    }
}
