/*
 * PopupAction.java
 *
 * (C) Copyright IBM Corp. 2002 2004
 * 
 * THIS FILE IS PROVIDED UNDER THE TERMS OF THE COMMON PUBLIC LICENSE 
 * ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THIS FILE 
 * CONSTITUTES RECIPIENTS ACCEPTANCE OF THE AGREEMENT.
 *
 * You can obtain a current copy of the Common Public License from
 * http://oss.software.ibm.com/developerworks/opensource/license-cpl.html
 *
 * Author: Viktor Mihajlovski <mihajlov@de.ibm.com>
 * Contributors: Rajarshi Das <rajarshi@in.ibm.com>
 *
 * Description: This action just echoes the arguments after the indication
 *              has arrived. The code has been derived from the source 
		file called HelloAction.java. 
 */

package com.ibm.wbem.evsub;

import org.snia.wbem.cim.*;
import org.snia.wbem.client.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class PopupAction implements IndAction {
    String parameters[];
    public PopupAction(String parms[]) {
	parameters=parms;
    }
    public void process(CIMEvent event) {
	JFrame frame = new JFrame("Event Notification");
	frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
	//frame.setBounds(100,100,200,80);
	frame.setBounds(100,100,300,250);
	//frame.reshape(100,100,300,250);
	//String labelText = new String();
	String areaText = new String();
	for (int i=0; i < parameters.length; i++) {
	    areaText += IndPropertyResolve.resolve(parameters[i],
						     event);
	}
	JPanel panel = new JPanel();
	//JLabel label = new JLabel(labelText);
	JTextArea textarea = new JTextArea(areaText);
	textarea.setLineWrap(true);
	JLabel empty = new JLabel();
	empty.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	empty.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	JButton button = new JButton();
	button.setAction(new AbstractAction("Close") {
		public void actionPerformed(ActionEvent ae) {
		    System.out.println("action -> " + ae.getActionCommand());
		    JFrame thisframe = (JFrame)getValue("owner");
		    thisframe.dispose();
		};
	    });
	button.getAction().putValue("owner",frame);
	panel.setLayout(new BorderLayout());
	panel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	//panel.add(label,BorderLayout.NORTH);
	panel.add(textarea,BorderLayout.NORTH);
	panel.add(empty,BorderLayout.CENTER);
	panel.add(button,BorderLayout.SOUTH);
	frame.getContentPane().add(panel);
	frame.pack();
	frame.setVisible(true);
	System.out.print("PopupAction: ");
	System.out.println();
    }
}
