/*
 * parseelareport.c
 *
 * (C) Copyright IBM Corp. 2004
 *
 * THIS FILE IS PROVIDED UNDER THE TERMS OF THE COMMON PUBLIC LICENSE
 * ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THIS FILE
 * CONSTITUTES RECIPIENTS ACCEPTANCE OF THE AGREEMENT.
 *
 * You can obtain a current copy of the Common Public License from
 * http://oss.software.ibm.com/developerworks/opensource/license-cpl.html
 *
 *    Author: Rajarshi Das <rajarshi@in.ibm.com>
 *
 * Description: The parser returns a structure with the event log
 * analysis data filled in.
 */

/*Note: 
 * the srn error text data is supposed to be in no more than a single line.
 * All subsequent lines of data for the srn error text field are omitted.
*/

# include "../indprovider.h"

void fill_ela_report(char *filename,elareport *elar) 
{
	FILE *fp;
	char line[300],temp1[100],corr_text[10][200],corr_text1[2000],loc[20],partnum[20],refcode[20];
	char *temp,data[100],*tokbuf[100];
	int menugoal = 0,srn = 0,i = 0,j=0,l=0,fieldcount=0,iter=0;
	
	fp = fopen(filename,"r");
	perror("fopen");
	
	elar->datetime[0] = '\0';
	elar->srn[0] = '\0';
	elar->srnerrortext[0] = '\0';
	elar->menunumber[0] = '\0';
	elar->menugoalerrortext[0] = '\0';
	elar->location[0] = '\0';
	elar->partnumber[0] = '\0';
	elar->errorlogseqno[0] = '\0';

	while (fgets(line,sizeof(line),fp) != NULL) 
	{
	
		if (strstr(line,"Date/Time") != NULL) 
		{
			strtok_r(line,":",tokbuf);
			temp = strtok_r(NULL,"\n",tokbuf);
			tokbuf[0][0] = '\0';
			if (temp[0] == ' ')
			{
			 for (i=1,j=0;i<strlen(temp);i++,j++)
				 data[j] = temp[i];
			 
			data[j] = '\0';
			}
		else snprintf(data,sizeof(data),"%s",temp);
		snprintf(elar->datetime,sizeof(elar->datetime),"%s",data);
		fprintf(stderr,"\nelar->datetime:%s",elar->datetime);
		data[0] = '\0';
		temp[0] = '\0';
		}
		else
		if (strstr(line,"SRN") != NULL) 
		{
			srn = 1;
			strtok_r(line,":",tokbuf);
			temp = strtok_r(NULL,"\n",tokbuf);
			tokbuf[0][0] = '\0';
			if (temp[0] == ' ')
			{
			 for (i=1,j=0;i<strlen(temp);i++,j++)
				data[j] = temp[i];
			 data[j] = '\0';
			}
			else snprintf(data,sizeof(data),"%s",temp);
			snprintf(elar->srn,sizeof(elar->srn),"%s",data);
			fprintf(stderr,"\nelar->srn:%s",elar->srn);
			data[0] = '\0';
			temp[0] = '\0';
		}	
		else
		if (strstr(line,"Menu Number") != NULL) 
		{
			menugoal = 1;
			strtok_r(line,":",tokbuf);
			temp = strtok_r(NULL,"\n",tokbuf);
			tokbuf[0][0] = '\0';
			if (temp[0] == ' ')
			{
			 for (i=1,j=0;i<strlen(temp);i++,j++)
				data[j] = temp[i];
			 data[j] = '\0';
			}
			else snprintf(data,sizeof(data),"%s",temp);
			snprintf(elar->menunumber,sizeof(elar->menunumber),"%s",data);
			fprintf(stderr,"\nelar->menunumber:%s",elar->menunumber);
			data[0] = '\0';
			temp[0] = '\0';
		}
	 	else	
		if (strstr(line,"Text:") != NULL) 
		{ 						
		 if ((srn == 1) && (menugoal == 0)) 
		 {					// only srn report
		   strtok_r(line,":",tokbuf);
	 	   temp = strtok_r(NULL,"\n",tokbuf); 
		   tokbuf[0][0] = '\0';
 		   if (temp[0] == ' ')
		   {
		    for (i=1,j=0;i<strlen(temp);i++,j++)
			data[j] = temp[i];
		    data[j] = '\0';
		   }
		   else snprintf(data,sizeof(data),"%s",temp);
		   snprintf(elar->srnerrortext,sizeof(elar->srnerrortext),"%s",data);
		   fprintf(stderr,"\nelar->srnerrortext:%s",elar->srnerrortext);
		   data[0] = '\0';
		   temp[0] = '\0';
		 } 
		 else if (menugoal == 1) 
		 {			// only menugoal report. Need to look for EndText here.
		   iter=0;
	 	   strtok_r(line,":",tokbuf);
	 	   temp = strtok_r(NULL,"\n",tokbuf);
		   tokbuf[0][0] = '\0';
		   if (temp[0] == ' ')
	   	   {
		     for (i=1,j=0;i<strlen(temp);i++,j++)
		 	data[j] = temp[i];
		    data[j] = '\0';
		   }
		   else snprintf(data,sizeof(data),"%s",temp);
		   corr_text[iter][0] = '\0';
		   snprintf(corr_text[iter],sizeof(corr_text[iter]),"%s",data);
		   data[0] = '\0';
		   temp[0] = '\0';
		   iter++;
		   fgets(line,sizeof(line),fp);
		   while  ((strstr(line,"EndText") == NULL) && (iter < 10))
		   {
		     corr_text[iter][0] = '\0';
		     snprintf(corr_text[iter],sizeof(corr_text[iter]),"%s",line);
		     fgets(line,sizeof(line),fp);
		     iter++;
		   }
		   if ((iter == 10) && (strstr(line,"EndText") == NULL))
		   {
		    corr_text[iter][0] = '\0';
		    snprintf(corr_text[iter],sizeof(corr_text[iter]),"<text truncated" 
		 	 "due to overflow>EndText");
		   }
		   else 
		   {
		    corr_text[iter][0] = '\0';
		    snprintf(corr_text[iter],sizeof(corr_text[iter]),"EndText"); 
		   }
		   corr_text1[0] = '\0';
		   for (i=0;i<=iter;i++)
		   {
		    strncat(corr_text1,corr_text[i],strlen(corr_text[i]));
		   }
		   snprintf(elar->menugoalerrortext,sizeof(elar->menugoalerrortext),"%s",corr_text1);
		   fprintf(stderr,"\nelar->menugoalerrortext:%s",elar->menugoalerrortext);
							
		 }
		}
		else
		if (strstr(line,"FRU") != NULL) 
		{
		 strtok_r(line,":",tokbuf); // parsing the FRU location and part number here.
	 	 temp = strtok_r(NULL,"\n",tokbuf);
		 tokbuf[0][0] = '\0';
		 for (i=0;i<strlen(temp);i++)
	 	 {
		  if ((temp[i] == ' ') || (temp[i] == '\t'))
		  {
	           j = i+1;
		   while ((temp[j] == ' ') || (temp[j] == '\t'))
		   {
	                j++;
	           }
		   l=0;
		   temp1[0] = '\0';
	           while ((temp[j] != ' ') && (temp[j] != '\t')
	                          && (temp[j] != '\0'))
	 	   {
		    temp1[l] = temp[j];
		    j++;
	            l++;
		   }
		   fieldcount++;
		   temp1[l] = '\0';
		   if (fieldcount == 1)
                   {
		    snprintf(elar->location,sizeof(elar->location),"%s",temp1);
		    fprintf(stderr,"\nelar->location:%s",elar->location);
		   }	
		   if (fieldcount == 2)
                   {
		    snprintf(elar->partnumber,sizeof(elar->partnumber),"%s",temp1);
		    fprintf(stderr,"\nelar->partnumber:%s",elar->partnumber);
		   }
		   fflush(stdout);
	           i=j-1; // neednot iterate upto the point already reached ..
	           j=0;
	          }
		 }
		 fieldcount=0;
		 temp[0] = '\0';
		 loc[0] = '\0';
		 partnum[0] = '\0';
		 refcode[0] = '\0';
		}
		else
		if (strstr(line,"Error Log Sequence") != NULL) 
		{
	  	 strtok_r(line,":",tokbuf);
		 temp = strtok_r(NULL,"\n",tokbuf);
		 tokbuf[0][0] = '\0';
		 if (temp[0] == ' ')
		 {
		  for (i=1,j=0;i<strlen(temp);i++,j++)
			data[j] = temp[i];
		  data[j] = '\0';
		 }
		 else snprintf(data,sizeof(data),"%s",temp);
		 snprintf(elar->errorlogseqno,sizeof(elar->errorlogseqno),"%s",data);
		 fprintf(stderr,"\nelar->errorlogseqno:%s",elar->errorlogseqno);
		 data[0] = '\0';
		 temp[0] = '\0';
		}
	
	}
	fclose(fp);
	
}
