# Defaults - overridable
PACKAGE?=classes

OBJECTROOT=$(CIMCLIENT_ROOT)
MODROOT=$(OBJECTROOT)


# object Path
OBJBASE=$(CIMCLIENT_OBJPATH)/obj
OBJECTLIB=$(CIMCLIENT_OBJPATH)/lib

INSTALLBASE=$(OBJBASE)
INSTALLLIB=$(OBJECTLIB)
INSTALLROOT=$(JAVACIM_OBJPATH)/install

MY_ROOT=$(PEGASUS_ROOT)/src/Java
CIMCLIENT_ROOT=$(MY_ROOT)

CIMCLIENT_OBJPATH=$(JAVACIM_OBJPATH)/classes

JAVACIM_OBJPATH=$(CIMCLIENT_ROOT)
XML_PARSER_CPATH=/usr/java/xerces-1_4_4/xerces.jar

JAVA_HOME=/usr/java/j2sdk1.4.1_07
JAVAPATH=$(JAVA_HOME)/bin
JDK_CLASS_PATH=$(JAVA_HOME)/jre/lib/rt.jar
JSSE_CLASS_PATH=$(JAVA_HOME)/jre/lib/jsse.jar
XML_PARSER_CPATH=/usr/java/xerces-1_4_4/xerces.jar
CIMCLIENT_CLASSES=$(CIMCLIENT_OBJPATH)/obj/

#CLASSPATH=$(CIMCLIENT_ROOT)/cimclient:$(XML_PARSER_CPATH):$(JDK_CLASS_PATH):$(JSSE_CLASS_PATH):$(XML_PARSER_CPATH):$(CIMCLIENT_ROOT)/:$(CIMCLIENT_CLASSES):.:

CLASSPATH=.:$(CIMCLIENT_ROOT)/cimclient:$(XML_PARSER_CPATH):$(JDK_CLASS_PATH):$(JSSE_CLASS_PATH):$(CIMCLIENT_ROOT)/:
SYSCLASSPATH=$(CLASSPATH)

RM=rm
JAR=jar
JAVAC=javac

JFLAGS=-g  -classpath  $(SYSCLASSPATH):$(EXTCLASSPATH)

.SUFFIX: .java .class

$(OBJBASE)/$(PACKAGEDIR)/%.class: %.java
	$(JAVAC) $(JFLAGS) $<

.PHONY: $(SUBDIRS)

all: $(OBJBASE) $(SUBDIRS) \
	$(patsubst %.java,$(OBJBASE)/$(PACKAGEDIR)/%.class,$(CLASSES))

$(SUBDIRS):
	$(MAKE) -C $@

$(OBJBASE):
	mkdir -p $@


package: all
	mkdir -p $(OBJECTLIB)
	$(JAR) cmf $(CIMCLIENT_ROOT)/MANIFEST.JCLIENT $(OBJECTLIB)/$(PACKAGE).jar -C $(OBJBASE)/ $(PACKAGEDIR)

install: package
	mkdir -p $(INSTALLLIB)
	cp $(OBJECTLIB)/$(PACKAGE).jar $(INSTALLLIB)

clean:
	$(RM) -f $(OBJECTLIB)/$(PACKAGE).jar
	$(RM) -rf $(OBJBASE)
	$(RM) -f *.class
